﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Data.SqlServerCe;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Integration;

namespace test_Gantt_002
{
    public partial class Form1 : Form
    {
        test009DataSet.ProjectRow data;
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
        }

        void Form1_Load(object sender, EventArgs e)
        {
            ElementHost elhost = new ElementHost();
            elhost.Size = new System.Drawing.Size(1000, 600);
            UserControl1 wpfctl = new UserControl1();
            elhost.Child = wpfctl;
            GenerateData();
            // set the datacontext for UserControl.
            wpfctl.DataContext = this;
            this.tabPage2.Controls.Add(elhost);

        }

        private void Form1_Load_1(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'test009DataSet.Project' table. You can move, or remove it, as needed.
            this.projectTableAdapter.Fill(this.test009DataSet.Project);
        }

        public ObservableCollection<Model> Project
        {
            get;
            set;
        }

        void GenerateData()
        {
            //Generate a record for each row in the Dataset and add it into the collection.
            Project = new ObservableCollection<Model>();
            var rowCount = (((this.gridGroupingControl1).DataSource as BindingSource).DataSource as System.Data.DataSet).Tables[0].Rows.Count;
            var record = (((this.gridGroupingControl1).DataSource as BindingSource).DataSource as System.Data.DataSet).Tables[0].Rows;
            for (int i = 0; i < rowCount; i++)
            {
                data = record[i] as test009DataSet.ProjectRow;
                
                Project.Add(new Model()
                {
                    Row = data,
                    ProjectName = data.ProjectName,
                    TaskName = data.TaskName,
                    Start = data.Start,
                    Finish = data.Finish,
                    Progress = data.Progress,
                    ResourceName = data.ResourceNames,
                    Cost = data.Cost,
                    CostVariance = data.CostVariance,
                    StartVarience = data.StartVariance,
                    FinishVarience = data.FinishVariance,
                    BaselineEnd = data.BaselineFinish,
                    BaselineStart = data.BaselineStart

                });
            }
            //To refresh the grid grouping control when the changes occured.
            test009DataSet.Tables[0].RowChanged += Form1_RowChanged;
        }

        private void Form1_RowChanged(object sender, DataRowChangeEventArgs e)
        {
            //Forces the grid to invalidate the modifications done and repaints the parent table and child table also.
            this.gridGroupingControl1.Refresh();
            string connectionString = @"Data Source=|DataDirectory|\test009.sdf;Password=test;Persist Security Info=True";

            try
            {
                 
                using (SqlCeConnection connection = new SqlCeConnection(connectionString))
                {
                    SqlCeDataAdapter adapter = new SqlCeDataAdapter();
                    adapter.SelectCommand = new SqlCeCommand("Select * from Project", connection);
                    SqlCeCommandBuilder builder = new SqlCeCommandBuilder(adapter);

                    connection.Open();

                    DataSet customers = new DataSet();
                    adapter.Fill(customers);

                    var row = customers.Tables[0].Rows[test009DataSet.Tables[0].Rows.IndexOf(e.Row)];
                    row["TaskName"] = (e.Row as test009DataSet.ProjectRow).TaskName;
                    row["ProjectName"] = (e.Row as test009DataSet.ProjectRow).ProjectName;
                    row["Start"] = (e.Row as test009DataSet.ProjectRow).Start;
                    row["Finish"] = (e.Row as test009DataSet.ProjectRow).Finish;
                    row["Progress"] = (e.Row as test009DataSet.ProjectRow).Progress;
                    row["ResourceNames"] = (e.Row as test009DataSet.ProjectRow).ResourceNames;
                    row["Cost"] = (e.Row as test009DataSet.ProjectRow).Cost;
                    row["CostVariance"] = (e.Row as test009DataSet.ProjectRow).CostVariance;
                    row["StartVariance"] = (e.Row as test009DataSet.ProjectRow).StartVariance;
                    row["FinishVariance"] = (e.Row as test009DataSet.ProjectRow).FinishVariance;
                    row["BaselineFinish"] = (e.Row as test009DataSet.ProjectRow).BaselineFinish;
                    row["BaselineStart"] = (e.Row as test009DataSet.ProjectRow).BaselineStart;

                    DataRow[] rows = new DataRow[] { row };
                    adapter.Update(rows);
                    connection.Close();

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

    }

    //Create a template class with properties to hold the each column values of DataSet
    public class Model:INotifyPropertyChanged
    {
        private DataRow _row { get; set; }
        private string _projectName { get; set; }
        private string _taskName { get; set; }
        private DateTime _start { get; set; }
        private DateTime _finish { get; set; }
        private decimal _progress { get; set; }
        private string _resourceName { get; set; }
        private decimal _cost { get; set; }
        private decimal _costVariance { get; set; }
        private decimal _finishVarience { get; set; }
        private decimal _startVarience { get; set; }
        private DateTime _baselineStart { get; set; }
        private DateTime _baselineEnd { get; set; }

        public DataRow Row
        {
            get
            {
                return _row;
            }
            set
            {
                _row = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Row"));
            }
        }
        public string ProjectName
        {
            get
            {
                return _projectName;
            }
            set
            {
                _projectName = value;
                OnPropertyChanged(new PropertyChangedEventArgs("ProjectName"));
            }
        }
        public string TaskName
        {
            get
            {
                return _taskName;
            }
            set
            {
                _taskName = value;
                OnPropertyChanged(new PropertyChangedEventArgs("TaskName"));
            }
        }
        public DateTime Start
        {
            get
            {
                return _start;
            }
            set
            {
                _start = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Start"));
            }
        }
        public DateTime Finish
        {
            get
            {
                return _finish;
            }
            set
            {
                _finish = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Finish"));
            }
        }
        public decimal Progress
        {
            get
            {
                return _progress;
            }
            set
            {
                _progress = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Progress"));
            }
        }
        public string ResourceName
        {
            get
            {
                return _resourceName;
            }
            set
            {
                _resourceName = value;
                OnPropertyChanged(new PropertyChangedEventArgs("ResourceName"));
            }
        }
        public decimal Cost
        {
            get
            {
                return _cost;
            }
            set
            {
                _cost = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Cost"));
            }
        }
        public decimal CostVariance
        {
            get
            {
                return _costVariance;
            }
            set
            {
                _costVariance = value;
                OnPropertyChanged(new PropertyChangedEventArgs("CostVariance"));
            }
        }
        public decimal FinishVarience
        {
            get
            {
                return _finishVarience;
            }
            set
            {
                _finishVarience = value;
                OnPropertyChanged(new PropertyChangedEventArgs("FinishVarience"));
            }
        }
        public decimal StartVarience
        {
            get
            {
                return _startVarience;
            }
            set
            {
                _startVarience = value;
                OnPropertyChanged(new PropertyChangedEventArgs("StartVarience"));
            }
        }
        public DateTime BaselineStart
        {
            get
            {
                return _baselineStart;
            }
            set
            {
                _baselineStart = value;
                OnPropertyChanged(new PropertyChangedEventArgs("BaselineStart"));
            }
        }
        public DateTime BaselineEnd
        {
            get
            {
                return _baselineEnd;
            }
            set
            {
                _baselineEnd = value;
                OnPropertyChanged(new PropertyChangedEventArgs("BaselineEnd"));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            var changes = this.PropertyChanged;

            if (changes != null)
            {
                changes(this, e);
                RefreshData();
            }
        }

        private void RefreshData()
        {
            
            (Row as test009DataSet.ProjectRow).ProjectName = ProjectName;
            (Row as test009DataSet.ProjectRow).TaskName = TaskName;
            (Row as test009DataSet.ProjectRow).Start = Start;
            (Row as test009DataSet.ProjectRow).Finish = Finish;
            (Row as test009DataSet.ProjectRow).Progress = Progress;
            (Row as test009DataSet.ProjectRow).ResourceNames = ResourceName;
            (Row as test009DataSet.ProjectRow).Cost = Cost;
            (Row as test009DataSet.ProjectRow).CostVariance = CostVariance;
            (Row as test009DataSet.ProjectRow).StartVariance = StartVarience;
            (Row as test009DataSet.ProjectRow).FinishVariance = FinishVarience;
            (Row as test009DataSet.ProjectRow).BaselineFinish = BaselineEnd;
            (Row as test009DataSet.ProjectRow).BaselineStart = BaselineStart;
            
        }
    }

}
